var game = new Phaser.Game(1100, 550, Phaser.AUTO, null, {preload: preload, create: create, update: update});

var perso;
var startButton;
var reloadButton;
var stock = []; // contiendra les sprites décrivant le stock

var width_ratio = .7;

var perso_a_bouger = false; // booléen utilisé dans la fonction update de Phaser pour savoir si on change la place du perso (si on déplace le perso) 
var commandes_a_traiter=[]; 

var compt = 0;
var lim_temps = 25; // pour rafraichissement dans déplacement du perso
var score = 0;

var parameters = location.search.substring(1).split("&");
var temp = parameters[0].split("=");
lab = unescape(temp[1]); // récupère ici le numéro du labyrinthe passé en argument

if (lab==2){   // tableau numéro 2
	var tableau = { taille: {x:4, y:4},
					perso : {x:0, y:3, orientation: 'E'}, //position initiale
					question : [['-2+1','-1*(-1)+1','1.5-2.5','-2+2'],
								['3-2','2-3*(-1)','-1+1-2','1/2-5/2'],
								['2-(-3)','3*(-4)+10','-7+5','-2-2'],
								['2+3*(-4)','3-4','(-1)*(-7)+5','2-2*2']],
					cadeau : [[['F'],['E','F'],['F'],''],
								['',['E','L','L','F','F','R','R'],['L','R','R','F','F'],['E','L','L','F','F']],
								[['F','F','F'],['E','L','L','R','R','F','F','F'],['E','F','F','L','R'],''],
								[['L','L','R','F','F'],'',['E','F','F','L'],['E','L','L','F','F','R','R']]],
					objectif : -2,
					score_a_atteindre : 5
	}
}
else{ // tableau par défaut
	var tableau = { taille: {x:3, y:3},
					perso : {x:0, y:2, orientation: 'N'}, //position initiale
					question : [['-2+1','-1+1','0-2'],
								['3-2','2-3','-1-1+2'],
								['0-1','2-4','-6+5']],
					cadeau : [[['E','F','F','L','R','R'],['E','E','E'],''],
								['',['E','L','L','F','F','R','R'],''],
								[['E','L','L','R','F','F'],'',['E','F','F','L']]],
					objectif : -1,
					score_a_atteindre : 4
	}	
}

var tableCorrespondanceOrientation = [['S',0],['W',1],['E',2],['N',3]]
var OrientationMap = new Map(tableCorrespondanceOrientation) // pour faire correspondre les directions avec le numéro de l'image correspondante dans le png

var tableCorrespondanceCommandes = [['F',0],['E',1],['L',2],['R',3]]
var CommandesMap = new Map(tableCorrespondanceCommandes) // pour faire correspondre les commandes avec le numéro de l'image correspondante dans le png

var commandes = ['F','F','L','E','R']; // commandes disponibles initialement pour le joueur
commandes.sort();

var grid;

var questionText = [...Array(tableau.taille.x)].map(e => Array(tableau.taille.y)); // Crée un tableau vide de x sur y

function preload() {
    game.scale.scaleMode = Phaser.ScaleManager.SHOW_ALL;	// alternative : NO_SCALE
    game.scale.pageAlignHorizontally = true;
    game.scale.pageAlignVertically = true;
    game.stage.backgroundColor = '#eee';
    game.load.spritesheet('perso', 'images/heros.png',56,56);
	game.load.spritesheet('button', 'images/button.png', 120, 40);
	game.load.spritesheet('button_reload', 'images/button_reload.png', 120, 40);	
	game.load.spritesheet('button_next_lab', 'images/button_next_lab.png', 120, 40);	
	game.load.spritesheet('commande', 'images/arrows.png',64, 64);	
}

function reload(){
	window.location.reload();
}

function load_next_labyrinth(){
	if (lab==2){
		lab = 1;}
	else{
		lab = 2;
	}
	window.location.href="integer chaser.html?lab="+lab;
}

function create() {
	// crée et affiche la grille
	grid = new AlignGrid(tableau.taille.x, tableau.taille.y, game, width_ratio); // width_ratio indique que la grille n'occupera que 75% de la largeur du game 
	grid.show();
	
	// Affiche le bouton START
	startButton = game.add.button(game.world.width*(width_ratio+1)/2, game.world.height*0.333, 'button', startGame, this, 1, 0, 2);
	startButton.anchor.set(0.5,0.5);
	
	// Affiche le bouton RECOMMENCER
	reloadButton = game.add.button(game.world.width*(width_ratio+1)/2, game.world.height*0.88, 'button_reload', reload, this, 1, 0, 2);
	reloadButton.anchor.set(0.5,0.5);

	// Affiche le bouton TABLEAU SUIVANT
	reloadButton = game.add.button(game.world.width*(width_ratio+1)/2, game.world.height*0.96, 'button_next_lab', load_next_labyrinth, this, 1, 0, 2);
	reloadButton.anchor.set(0.5,0.5);
	
	// Affiche le personnage
    perso = game.add.sprite(50, 50, 'perso');
	perso.anchor.set(0.5,0.5);
	perso.frame = OrientationMap.get(tableau.perso.orientation);
	grid.placeAt(tableau.perso.x, tableau.perso.y, perso); // place le perso dans la grille à sa position de départ
	
	// Affiche les questions
    textStyle = { font: '36px Arial', fill: '#0095DD' };
    for (var i = 0 ; i < tableau.taille.x ; i++){
		for (var j = 0 ; j < tableau.taille.y ; j++){
			questionText[i][j] = game.add.text(5+20*i, 5+20*j, tableau.question[i][j], textStyle);
			questionText[i][j].anchor.set(0.5);
			grid.placeAt(i,j,questionText[i][j]); // place le texte dans la grille à sa position
		}
	}
	
	// Affiche l'objectif
	objTxt = game.add.text(game.world.width*(width_ratio+1)/2,game.world.height*.4667,'Chassez les '+tableau.objectif+' !', textStyle);
	objTxt.anchor.set(0.5,0.5);
	
	// Affiche le score
	scoreTxt = game.add.text(game.world.width*(width_ratio+1)/2,game.world.height*.52,'Score : '+score, textStyle);
	scoreTxt.anchor.set(0.5,0.5);
    textStyle = { font: '72px Arial', fill: '#0095DD' };
	victoireTxt = game.add.text(game.world.width/2,game.world.height*.58,'', textStyle);
	victoireTxt.anchor.set(0.5,0.5);
	
	// Affiche les commandes disponibles
	AfficheCommandes(commandes);
 }

function update() {
	
	if (perso_a_bouger){ // si le booléen autorise les déplacements
		
		if (commandes_a_traiter.length > 0){ // s'il y a des déplacements à faire dans la liste de déplacements 
			compt += 1;
			if (compt%lim_temps==0){ // lorsque le compteur donne le top
				
				ImpactePerso(commandes_a_traiter[0]) // on exécute tjs la première commandes à traiter, puisque dès qu'exécutée elle sera supprimée de la liste
				
				commandes_a_traiter.shift();  // et on compte qu'on a fait le déplacement (on supprime le premier élément de la liste) 
			}
		}
		else{
			perso_a_bouger = !perso_a_bouger;
			compt = 0;
		}
	}
}

function startGame() {

	commandes_a_traiter = CommandesDansOrdreChoisi(IndexMinToMax(LitCommandesSoumises(stock))); // lit les commandes disposées par l'utilisateur au-dessus du bouton Start
	if (commandes_a_traiter[commandes_a_traiter.length-1] != 'E'){
		commandes_a_traiter.push('Z'); // on force un 'Z' symbolisant la fin de chaîne si on ne finit pas par un "Eat"
	}
	console.log(commandes_a_traiter);
	console.log(commandes_a_traiter.length);

	perso_a_bouger = !perso_a_bouger
	console.log(perso_a_bouger)
}


function AfficheCommandes(commandes){
	stock=[];
	// Affiche les commandes disponibles
	for (var i = 0; i < commandes.length; i++) {
		//console.log(game.world.width*(width_ratio+1)/2+i*64);
        stock[i] = game.add.sprite(game.world.width*(width_ratio+0.05)+(i%5)*64, game.world.height*(0.666+Math.trunc(i/5)*0.125), 'commande');
		stock[i].frame = CommandesMap.get(commandes[i]);
		stock[i].anchor.set(0.5, 0.5);
		stock[i].inputEnabled = true;
		stock[i].input.enableDrag();
        }
}

function ImpactePerso(cmd){
	
	if ((cmd == 'L') || (cmd == 'R') || (cmd == 'F')){
		index = commandes.indexOf(cmd);
		if (index != -1){
			commandes.splice(index,1);
		}
	}
	
	if (cmd == 'L'){
			if (tableau.perso.orientation == 'N') {tableau.perso.orientation = 'W'}
			else if (tableau.perso.orientation == 'W') {tableau.perso.orientation = 'S'}
			else if (tableau.perso.orientation == 'S') {tableau.perso.orientation = 'E'}
			else {tableau.perso.orientation = 'N'}
			
	}
	else if (cmd == 'R'){
			if (tableau.perso.orientation == 'N') {tableau.perso.orientation = 'E'}
			else if (tableau.perso.orientation == 'W') {tableau.perso.orientation = 'N'}
			else if (tableau.perso.orientation == 'S') {tableau.perso.orientation = 'W'}
			else {tableau.perso.orientation = 'S'}
				
	}
	else if (cmd == 'F'){
			
			if (tableau.perso.orientation == 'N') {tableau.perso.y = ajoute_y(tableau.perso.y, -1);}
			else if (tableau.perso.orientation == 'W') {tableau.perso.x = ajoute_x(tableau.perso.x,-1);}
			else if (tableau.perso.orientation == 'S') {tableau.perso.y = ajoute_y(tableau.perso.y, 1);}
			else {tableau.perso.x = ajoute_x(tableau.perso.x,1);}						
	}
	else if ((cmd == 'E') || (cmd == 'Z')){ // E comme "eat", signifie ici que le joueur choisit le calcul
						
			if (cmd == 'E'){
				if (eval(tableau.question[tableau.perso.x][tableau.perso.y]) == tableau.objectif) {
					console.log("ramasse cadeau");
					score += 1;
					scoreTxt.text = 'Score : ' + score;
					if (score == tableau.score_a_atteindre){
						victoireTxt.text = 'Victoire !';
					}
					
				}
				else {
					console.log("ramasse tes dents");
				}
				
				questionText[tableau.perso.x][tableau.perso.y].destroy(); // efface la question écrite sur le plateau*
				tableau.question[tableau.perso.x][tableau.perso.y]=''; // On efface également la question dans la variable descriptive 
			}
			
			// Destruction du stock restant 			
			for (var i = 0 ; i < stock.length ; i++){
				stock[i].destroy();
			}
			stock = [];
			
			// Distribution des nouvelles pièces éventuelles
			if (cmd == 'E'){
				commandes = tableau.cadeau[tableau.perso.x][tableau.perso.y].slice(); // .slice() pour faire une vraie copie du tableau
				tableau.cadeau[tableau.perso.x][tableau.perso.y]=[] // on efface les cadeaux
			}
			else{
				//commandes = [];
			}
			
			AfficheCommandes(commandes);
	}
	
	perso.frame = OrientationMap.get(tableau.perso.orientation);	
	grid.placeAt(tableau.perso.x, tableau.perso.y, perso)
	console.log(tableau.perso.x, tableau.perso.y);
}

function ajoute_x(x, pas){
	if (( x + pas > -1 ) & ( x + pas < tableau.taille.x ))
		{return(x + pas);}
	else
		{return(x);}
}

function ajoute_y(y, pas){
	if (( y + pas > -1 ) & ( y + pas < tableau.taille.y ))
		{return(y + pas);}
	else
		{return(y);}
}

function IndexMinToMax(l){
	var m = [];
	for (var j = 0; j < l.length ; j++){
		if (Math.min(...l)<10000){ 
			m.push( l.indexOf(Math.min(...l)) );
			l[m[j]] = 10000;		 
		}		
	}
	return(m);
}

function LitCommandesSoumises(stock){
	var commandes_soumises = [];
	for (var i = 0 ; i < stock.length ; i++){
		if (stock[i].y < game.world.height*0.333){
			commandes_soumises.push(stock[i].x);
		}
		else{
			commandes_soumises.push(10000);
		}
	}
	return(commandes_soumises);
}

function CommandesDansOrdreChoisi(z){
	var l=[];
	for (var i = 0 ; i < z.length ; i++){
		l.push(commandes[z[i]]);
	}
	return(l);
}